<?php
/*###############################################################################################
	Title:	The Function Library
	Author:	Adam Sharp - asharp@andera.com
	Date:	11-15-2001
	Notes:	This is the pool of functions used in this application.
#################################################################################################*/ 


/*--------------------------------------------------------------------------
	bubbleSort() - Used to sort 2 dimensional arrays by it's Unix Timestamp
				   In this application, the Timestamp is found in element 0.
--------------------------------------------------------------------------*/
function bubbleSort($TwoDimArray,$SortOrder="ASC"){

		$temp= array(array());
		$MsgCount = sizeof($TwoDimArray);
		if($MsgCount) $ArrayDepth = sizeof($TwoDimArray[0]);
		
		for( $x=0; $x<$MsgCount; $x++ ){
			for( $y=0; $y<$MsgCount-1; $y++ ){
				if($SortOrder=="ASC"){
					if(intval($TwoDimArray[$y][0])>intval($TwoDimArray[$y+1][0])){
						for( $z=0; $z<$ArrayDepth; $z++ ) $temp[0][$z] = $TwoDimArray[$y][$z];
						for( $z=0; $z<$ArrayDepth; $z++ ) $TwoDimArray[$y][$z]=$TwoDimArray[$y+1][$z];
						for( $z=0; $z<$ArrayDepth; $z++ ) $TwoDimArray[$y+1][$z]=$temp[0][$z];
					}
				}else{
					if(intval($TwoDimArray[$y][0])<intval($TwoDimArray[$y+1][0])){
						for( $z=0; $z<$ArrayDepth; $z++ ) $temp[0][$z] = $TwoDimArray[$y][$z];
						for( $z=0; $z<$ArrayDepth; $z++ ) $TwoDimArray[$y][$z]=$TwoDimArray[$y+1][$z];
						for( $z=0; $z<$ArrayDepth; $z++ ) $TwoDimArray[$y+1][$z]=$temp[0][$z];
					}
				}
			}
		}
	
	return $TwoDimArray;
}



/*-------------------------------------------------------------------------
	OpenFile() - Handles File Opening for the application
-------------------------------------------------------------------------*/
function OpenFile($File,$Method){

	$FileNotFound = "
	<table bgcolor=\"#ffffff\" border=\"1\"><tr><td><center>
		<h1>Error!</h1>
		The Datafile: \"<b>".$File."</b>\" was not found!<br><br><br>
	</center></td></tr></table>";
	
	if(!file_exists($File)) die($FileNotFound);
	return fopen($File,$Method);
}

/*--------------------------------------------------------------------------
	getTime() - Used to calculate the template execution time.
--------------------------------------------------------------------------*/
function getTime(){
	$mtime = explode(" ",microtime());
	return ($mtime[1] + $mtime[0]);
}

/*--------------------------------------------------------------------------
	Format() - Used to prepare data to write to file
--------------------------------------------------------------------------*/
function Format($String){
	return urlencode(nl2br(htmlspecialchars($String)));
}

/*--------------------------------------------------------------------------
	UnFormat() - Used to prepare file data for HTML printing
--------------------------------------------------------------------------*/
function UnFormat($String){
	return trim(stripslashes(urldecode($String)));
}

/*--------------------------------------------------------------------------
	TrimString() - Used to Trim Strings for Output on the View Topic Page
--------------------------------------------------------------------------*/
function TrimString($String,$Length=10){
	$ReturnString = substr(trim($String),0,$Length);
	if( strlen(trim($String)) > $Length ) $ReturnString .= "...";
	return $ReturnString;
}

/*--------------------------------------------------------------------------
	GenerateUUID() - Used to generate Universal Unique Identifiers for TopicID's
--------------------------------------------------------------------------*/
function GenerateUUID(){
 	mt_srand((double)microtime()*1000000);
	return mt_rand();
}

/*--------------------------------------------------------------------------
	GetTopicCount() - Used to count the total number of Topics
--------------------------------------------------------------------------*/
function GetTopicCount(){
global $DataFile;
	$i=0;
	$TopicsAlreadyParsed = array();	
	$fp = OpenFile($DataFile, "r");
		while (!feof($fp)){
			fgets($fp, 4096);
			$temp = chop(fgets($fp, 4096));
			fgets($fp, 4096); 
			fgets($fp, 4096); 
			fgets($fp, 4096); 
			fgets($fp, 4096);
			if(!(in_array($temp,$TopicsAlreadyParsed)) && $temp > 0){
				$TopicsAlreadyParsed[$i]=$temp;
				$i++;
			}
		}
		
	fclose($fp);
	return sizeof($TopicsAlreadyParsed);
}

/*--------------------------------------------------------------------------
	GetQueryString() - Used to fetch the URL parameters
--------------------------------------------------------------------------*/
function GetQueryString(){
	global $HTTP_GET_VARS;
	$QueryString = "?";
	while ( list($key,$val) = each($HTTP_GET_VARS) ){
		$QueryString .= $key."=".$val."&";
	}
	$QueryString = substr($QueryString, 0, strlen($QueryString)-1); 
	return $QueryString;
}

/*--------------------------------------------------------------------------
	GetPreviousNext() - Used to generate the pagination links for the
						View Topics action.
--------------------------------------------------------------------------*/
function GetPreviousNext($RecordCount,$MaxLength=10) {
	global $PHP_SELF, $StartRow, $TableHeader_FontColor;
		$URL = GetQueryString();
		
		// Catch if StartRow is not defined in the URL
		if (!isset($StartRow)) $StartRow = 1;
		if ( $StartRow > $RecordCount || $StartRow < 1) $StartRow = 1;

		// Remove any previous StartRow definitions in the URL
		$QueryString = str_replace("StartRow=".$StartRow,"",$URL);
		
		// Prepate Query String for a new StartRow append
		if (strlen($QueryString)) {
			$QueryString = "?".$QueryString."&";
		} else {
			$QueryString = "?";
		}
		
		// Clean up the Query String, and build the new HREF
		$QueryString = str_replace("?&","?",$QueryString);
		$QueryString = str_replace("??","?",$QueryString);
		$QueryString = str_replace("&&","&",$QueryString);
		$HREF = $PHP_SELF.$QueryString."StartRow=";
		
		// Build Next String
		$NextRow = $StartRow + $MaxLength;
		
		if ($NextRow <= $RecordCount) {
			$NextString = "<a href=\"".$HREF.$NextRow."\"><span style=\"color: ".$TableHeader_FontColor."; font-size: 11px; text-decoration: none;\">Next &gt;&gt;</span></a>";
		} else {
			$NextString = "&nbsp;";
		}
		
		// Build Previous String
		$PreviousRow = $StartRow - $MaxLength;
		if (($StartRow > 1) AND ($StartRow <= $MaxLength)) $PreviousRow = 1;
	
		if ($PreviousRow >= 1) {
			$PreviousString = "<a href=\"".$HREF.$PreviousRow."\"><span style=\"color: ".$TableHeader_FontColor."; font-size: 11px; text-decoration: none;\">&lt;&lt; Previous</span></a>";
		} else {
			$PreviousString = "&nbsp;";
		}
		
		// Determine EndRow
		if ( ($NextRow - 1) > $RecordCount) {
			$EndRow = $RecordCount;
		} else {
			$EndRow = $NextRow - 1;
		}
		
		// Build Middle String
		$Start = $StartRow;
		if (!$RecordCount) $Start = 0;
		$MiddleString = "<span style=\"color: ".$TableHeader_FontColor."; font-size: 11px; text-decoration: none;\">(Viewing ".$Start." - ".$EndRow." of ".$RecordCount.")</span>"; 
		
		// Build the Return Array
		$ReturnArray = Array(5);
		$ReturnArray["Previous"] = $PreviousString;
		$ReturnArray["Middle"] = $MiddleString;
		$ReturnArray["Next"] = $NextString;
		$ReturnArray["StartRow"] = $StartRow;
		$ReturnArray["EndRow"] = $EndRow;

		return $ReturnArray;
	}

?>