<?php session_start();
/*###############################################################################################
	The Main Discussion Page
	
	Author:	Adam Sharp - asharp@andera.com
	Date:	11-10-2001
	Notes:	This application's logic is loosely based on the "FuseBox" methodology.  (www.FuseBox.org)
			This page is the Gateway for any/every thing that happens within this Application.
			Every module/action is preformed through this page by passing different values
			for "Action" through the URL.
#################################################################################################*/ 
require('app_Config.php');
require('app_Functions.php');

/*-----------------------------------------------------------------------
	If no Action is specified, set the default Action.
------------------------------------------------------------------------*/
if (!isset($Action)) { $Action = "ViewTopics"; }

/*-----------------------------------------------------------------------
	Main Application Switch Statement.
------------------------------------------------------------------------*/
switch ($Action){

	case 'ViewTopics':
		require('dsp_Header.php');
		require('dsp_ViewTopics.php');
		require('dsp_Footer.php');
		break;
	
	case 'ViewMessages':
		require('dsp_Header.php');
		require('dsp_ViewMessages.php');
		require('dsp_Footer.php');
		break;
	
	case 'PostTopic':
		require('dsp_Header.php');
		require('dsp_PostMessage.php');
		require('dsp_Footer.php');
		break;
	
	case 'PostMessage':
		require('dsp_Header.php');
		require('dsp_PostMessage.php');
		require('dsp_Footer.php');
		break;
		
	case 'DoPostMessage':
		require('act_PostMessage.php');
		break;
		
	case 'EditMessage':
		require('dsp_Header.php');
		require('dsp_PostMessage.php');
		require('dsp_Footer.php');
		break;
		
	case 'DoEditMessage':
		require('act_EditMessage.php');
		break;
		
	case 'EditMessageConfirm':
		require('dsp_Header.php');
		require('dsp_Confirm.php');
		require('dsp_Footer.php');
		break;
		
	case 'Login':
		require('dsp_Header.php');
		require('dsp_Login.php');
		require('dsp_Footer.php');
		break;
	
	case 'DoLogin':
		require('act_Login.php');
		break;
		
	case 'LoginConfirm':
		require('dsp_Header.php');
		require('dsp_Confirm.php');
		require('dsp_Footer.php');
		break;
	
	case 'Logout':
		require('act_Logout.php');
		break;
		
	case 'LogoutConfirm':
		require('dsp_Header.php');
		require('dsp_Confirm.php');
		require('dsp_Footer.php');
		break;
		
	case 'DoDeleteTopic':
		require('act_DeleteTopic.php');
		break;
		
	case 'DeleteTopicConfirm':
		require('dsp_Header.php');
		require('dsp_Confirm.php');
		require('dsp_Footer.php');
		break;
		
	case 'DoDeleteMessage':
		require('act_DeleteMessage.php');
		break;
		
	case 'DeleteMessageConfirm':
		require('dsp_Header.php');
		require('dsp_Confirm.php');
		require('dsp_Footer.php');
		break;
	
	default:
		require('dsp_Header.php');
		require('dsp_ViewTopics.php');
		require('dsp_Footer.php');
		break;
}

?>